Subject: Comments to Jeff's proposal and Chung's comments

From: [email-masked]
Date: Tue, 22 Feb 94 12:44:19 +0100

I agree with Chung, that the CPI-C document should describe,
what is a map name in SNA and OSI.

And I also agree with Chung, that there should also be some
information for implementors. 

SNI is extending it's transaction monitor UTM with OSI TP functions.
And we want to offer a possibility that users can define their own
abstract syntax. At the moment SNI does not plan to offer this functions
with the CPI-C interface. But the problems with our programming interface
are similar to those of CPI-C. Our solution is as follows:

  The administrator has to define every abstract syntax used in the
  monitor. An abstract syntax is defined by it's object identifier.
  The administrator also has to give a 1 to 8 byte character name to each
  abstract syntax. He also can define some transfer syntaxes to every
  abstract syntax.

  According to OSI on association establishment both partners must
  negotiate the set of abstract syntaxes and the transfer syntaxes.

  If a program wants to send user data it must use a map name.
  A map name consisting of 8 blanks means that UDT is used
  as abstract syntax. If the program wants to use any other abstract
  syntax, it has to use the administrator defined abstract syntax name
  as map name. Decoding and encoding is the job of the user program.
  The transaction monitor uses the map name to send the user data with
  the suitable presentation context id.

This is not exactly the solution of Jeff's proposal, because
decoding and encoding is the job of the user program.
But it makes clear that the CPI-C document should contain some similiar
information for implementors.

So i want to answer Chung's question 'What is a map name in OSI?'
as follows:

  A map name is a local defined name representing an abstract syntax.
  If a program uses no map names, UDT is used as abstract syntax.
 
This means that I want to change Jeff's proposal concerning the 
standard value of a map name. Jeff's proposal was the following:     

  If there is only one abstract syntax allowed on the association,
  this is the standard value.
  If there are more abstract syntaxes allowed, there is no standard
  value. The map name is mandatory.

My proposal:

  If programs use no map name, UDT is taken as abstract syntax.
  If UDT is not allowed on this association, the Set_Map_Name returns
  with CM_PROGRAM_PARAMETER_CHECK.
  If programs want to use other abstract syntaxes they have to
  use map names. If the use a map name not defined by the administrator
  or not allowed on this association, the Set_Map_Name returns
  with CM_PROGRAM_PARAMETER_CHECK.

Peter

-----------------------------------------------------------------------------
Peter Binninger                         Voice: (+49) 7531-87-4758
Computer Gesellschaft Konstanz mbH      Fax:   (+49) 7531-87-4888
(Siemens Nixdorf Informationssysteme)   Email: [email-masked]
Max-Stromeyer-Strasse 116
78467 Konstanz
Germany